%MESHDEMO2d Distmesh2d examples.
clear all;  close all; format short; format compact
% clc;
rand('state',1); % Always the same results this is important for evaluating the methods against each other.
set(gcf,'renderer','opengl');

fstats=@(p,t) fprintf('%d nodes, %d elements, min quality %.2f\n', ...
    size(p,1),size(t,1),min(simpqual(p,t)));

fprintf('Mesh on ellipse');
% echo on

%% Cb2 FIXED Points on surface

pfix = zeros(0,2);
pmpc = zeros(0,2);

tic
tol = 10^-8;

%% Function assignment

tic;
%% Element size distributions
h_max = 0.2;
h_min = 0.005;

%     h = @(p) hcircleout(p,h_max,h_min); % gauss
%     h = @(p) hradialgenerator(p,h_max,h_min); % gauss
% h = @(p) hradialgenerator2linear(p,h_max,h_min); %linear  Best variable version
% h = @(p) hradialgenerator2linearGrowthRate(p,h_max,h_min); %linear  Best variable version

h = @(p) huniform(p,h_max,h_min); h_min = h_max;% easiest to solve

%% Mesh run

% [p,t,its]=CB_distmesh2d_mpc(fdFunc,h,h_max,h_min,bounds,pfix,pmpc,tol,1);
A = rand(3,3);
b = rand(3,1);
x = A\b;


fdFunc = EllipseFunction1;
% fdFunc = EllipseFunction3;
% fdFunc = EllipseFunction1_1to1only;

 HW = [1 1
       1 2
       1 5
       1 10
       1 20
       1 40
       1 60
       1 80];
   
RatAreas = HW(:,1).*HW(:,2);
HWactual = HW./[RatAreas RatAreas ].^0.5;
% 
% HW = HW(1,:);
% HWactual = HWactual(1,:);


for Aspects = 1:1 %1:size(HW,1)
    fdFunc.Params = HWactual(Aspects,:);
    
    pfix = fdFunc.pfix;
    bounds = fdFunc.pbounds;
    
    for MPCType = 1:1:2
        rand('state',1) %Reset rand state so each one has same start point
        start = tic;
        [p,t,its,detailinf{MPCType}] = CB_distmesh2d_mpc(fdFunc,h,h_max,h_min,bounds,pfix,pmpc,tol,MPCType);
        detailinf{MPCType}.p = p;
        detailinf{MPCType}.t = t;
        detailinf{MPCType}.its = its;
        time = toc(start);
        qual = simpqual(p,t,1);
        qual = min(qual);
        Vals(MPCType,:) = [MPCType, its, time, qual, time/its];
    end
    
    savestring = ['Width_',num2str(round(fdFunc.Width,2)),'_Height_',num2str(round(fdFunc.Height,2)),'hmax_',num2str(round(h_max,2))]
    savestring = ['Result_',num2str(HW(Aspects,1)),'to',num2str(HW(Aspects,2)),'_Width_',num2str(round(fdFunc.Width,2)),'_Height_',num2str(round(fdFunc.Height,2)),'_hmax_',num2str(round(h_max,2))]


    figure(1)
    savefig([savestring, 'Lagrangian.fig'])
    
    figure(2)
    savefig([savestring, 'Master-Slave_Full_deriv.fig'])
    
%     figure(3)
%     savefig([savestring, 'Master-Slave_CB_deriv.fig'])
%     
    save([savestring,'.mat'])
    
end

