%MESHDEMO2d Distmesh2d examples.
clear all;  close all; format short; format compact
% clc;
rand('state',1); % Always the same results this is important for evaluating the methods against each other.
set(gcf,'renderer','opengl');

fstats=@(p,t) fprintf('%d nodes, %d elements, min quality %.2f\n', ...
    size(p,1),size(t,1),min(simpqual(p,t)));

fprintf('Mesh on ellipse');
% echo on

%% Cb2 FIXED Points on surface

pfix = zeros(0,3);
pmpc = zeros(0,3);

tic
tol = 10^-6;

%% Function assignment

% fdFunc = EllipseFunction3_3d;
fdFunc = EllipseFunction6_3d;

% pfix = fdFunc.pfix;
bounds = fdFunc.pbounds;

tic;
%% Element size distributions
h_max = .15;
h_min = .02;

%     h = @(p) hcircleout(p,h_max,h_min); % gauss
%     h = @(p) hradialgenerator(p,h_max,h_min); % gauss
h = @(p) huniform(p,h_max,h_min); h_min = h_max;% easiest to solve

a.p = @hradialgenerator2linearMeshGrowth_3d;
% a.p = @hradialgenerator2linear_3d;
% h = @(p) a.p(p,h_max,h_min); %linear  Best variable version

%% Mesh run

% [p,t,its]=CB_distmesh2d_mpc(fdFunc,h,h_max,h_min,bounds,pfix,pmpc,tol,1);
A = rand(3,3);
b = rand(3,1);
x = A\b;

 HW = [1 1 1
       1 2 2
       1 5 5
       1 10 10];
%        1 20
%        1 40
%        1 60
%        1 80];
   
RatAreas = HW(:,1).*HW(:,2).*HW(:,3);
HWactual = HW./[RatAreas RatAreas RatAreas].^(1/3);
% 
% HW = HW(1,:);
% HWactual = HWactual(1,:);

updateControl = 1000;
for Aspects = 3:size(HW,1)
    fdFunc.Params = HWactual(Aspects,:);
    
    pfix = fdFunc.pfix(h_max);
    bounds = fdFunc.pbounds;
    for MPCType = 1:2
        rand('state',1) %Reset rand state so each one has same start point
        tic
        [p,t,its,detailinf{MPCType}]=CB_distmesh3d_mpc(fdFunc,h,h_max,h_min,bounds,pfix,pmpc,tol,MPCType,updateControl);
        detailinf{MPCType}.p = p;
        detailinf{MPCType}.t = t;
        detailinf{MPCType}.its = its;
        figure(10+MPCType)
        %         simpplot(p,t,'p(:,2)>0');
        simpplot(p,t,'');
        time = toc;
        qual = simpqual(p,t,1);
        qual = min(qual);
        Vals(MPCType,:) = [MPCType, its, time, qual, time/its];
    end
    
    
    savestring1 = ['X_',num2str(HW(Aspects,1)),'_Y_',num2str(HW(Aspects,2)),'_Z_',num2str(HW(Aspects,3)),'hmax_',num2str(round(h_max,2)),'_UDC_',int2str(updateControl)]
    savestring = ['Result_',savestring1];
    
    figure(11)
    savefig([savestring, 'Lagrangian.fig'])
    
    figure(12)
    savefig([savestring, 'Master-Slave_Full_deriv.fig'])
    
%     figure(3)
%     savefig([savestring, 'Master-Slave_CB_deriv.fig'])
    
    save([savestring,'.mat'])
    Vals
end
