%MESHDEMO2d Distmesh2d examples.
clear all;   format short; format compact
% clc;
rand('state',1); % Always the same results this is important for evaluating the methods against each other.
set(gcf,'renderer','opengl');

fstats=@(p,t) fprintf('%d nodes, %d elements, min quality %.2f\n', ...
    size(p,1),size(t,1),min(simpqual(p,t)));

fprintf('Mesh on ellipse');
% echo on

%% Cb2 FIXED Points on surface

pfix = zeros(0,3);
pmpc = zeros(0,3);

tic
tol = 10^-5;

%% Function assignment

% fdFunc = EllipseFunction3_3d;
fdFunc = EllipseFunction6_3d;



tic;
%% Element size distributions
h_max = .2;
h_min = .02;
Hmaxs = [0.2 0.15 0.1 ];

for h_max = Hmaxs
    %     h = @(p) hcircleout(p,h_max,h_min); % gauss
    %     h = @(p) hradialgenerator(p,h_max,h_min); % gauss
    h = @(p) huniform(p,h_max,h_min); h_min = h_max;% easiest to solve
    
%     a.p = @hradialgenerator2linearMeshGrowth_3d;
    % a.p = @hradialgenerator2linear_3d;
    % h = @(p) a.p(p,h_max,h_min); %linear  Best variable version
    
    %% Mesh run
    
    % [p,t,its]=CB_distmesh2d_mpc(fdFunc,h,h_max,h_min,bounds,pfix,pmpc,tol,1);
    A = rand(3,3);
    b = rand(3,1);
    x = A\b;
    
    HW = [2 2 2
        1 2 2
        1 4 4
        1 8 8
        1 16 16
        1 32 32];
    
    
    RatVolumes = HW(:,1).*HW(:,2).*HW(:,2);
    HWactual = HW./[RatVolumes RatVolumes RatVolumes].^(1/3).*RatVolumes(1,1).^(1/3);
    %
    % HW = HW(1,:);
    % HWactual = HWactual(1,:);
    
    h = @(p) huniform(p,h_max,h_min);h_min = h_max;
    
    %     HWactual = HWactual(5:end,:);
    %     HW = HW(6:6,:);
    updateControl = 1000;
    GenerateFiles = true; updateControl = 1;
    for Aspects = 1:size(HWactual,1)
        
        try
            fdFunc.Params = HWactual(Aspects,:);
            pfix = fdFunc.pfix(h_max);
            bounds = fdFunc.pbounds;
            %         savestring1 = ['X_',num2str(round(fdFunc.Xscale,2)),'_Y_',num2str(round(fdFunc.Xscale,2)),'_Y_',num2str(round(fdFunc.Zscale,2)),'hmax_',num2str(round(h_max,2))]
            
            savestring1 = ['X_',int2str(HW(Aspects,1)),'_Y_',int2str(HW(Aspects,2)),'_Y_',int2str(HW(Aspects,3)),'hmax_',num2str(round(h_max,2))]
            filename = ['meshdata_' savestring1 '.mat'];
            
            for MPCType = 2:2
                rand('state',1) %Reset rand state so each one has same start point
                tic
                [p,t,its,detailinf{MPCType}]=CB_distmesh3d_mpc(fdFunc,h,h_max,h_min,bounds,pfix,pmpc,tol,MPCType,updateControl,filename,GenerateFiles);
                detailinf{MPCType}.p = p;
                detailinf{MPCType}.t = t;
                detailinf{MPCType}.its = its;
                figure(10+MPCType)
                %         simpplot(p,t,'p(:,2)>0');
                simpplot(p,t,'');
                time = toc;
                qual = simpqual(p,t,1);
                qual = min(qual);
                Vals(MPCType,:) = [MPCType, its, time, qual, time/its];
            end
            if GenerateFiles == false
                savestring = ['Result_',num2str(HW(Aspects,1)),'to_',savestring1];
                
                figure(11)
                savefig([savestring, 'Lagrangian.fig'])
                
                figure(12)
                savefig([savestring, 'Master-Slave_Full_deriv.fig'])
                
                %     figure(3)
                %     savefig([savestring, 'Master-Slave_CB_deriv.fig'])
                
                save([savestring,'.mat'])
            end
        catch
        end
    end
end
Vals