%MESHDEMO2d Distmesh2d examples.
clear all;  close all; format short; format compact
% clc;
rand('state',1); % Always the same results this is important for evaluating the methods against each other.
set(gcf,'renderer','opengl');

fstats=@(p,t) fprintf('%d nodes, %d elements, min quality %.2f\n', ...
    size(p,1),size(t,1),min(simpqual(p,t)));

fprintf('Mesh on ellipse');
% echo on

%% Cb2 FIXED Points on surface

pfix = zeros(0,2);
pmpc = zeros(0,2);

tic
tol = 10^-6;

%% Function assignment

fdFunc = EllipseFunction1;
% fdFunc = EllipseFunction3;

pfix = fdFunc.pfix;
bounds = fdFunc.pbounds;

tic;
%% Element size distributions
h_max = 0.1;
h_min = .01;

%     h = @(p) hcircleout(p,h_max,h_min); % gauss
%     h = @(p) hradialgenerator(p,h_max,h_min); % gauss
% h = @(p) hradialgenerator2linear(p,h_max,h_min); %linear  Best variable version
% h = @(p) hradialgenerator2linearGrowthRate(p,h_max,h_min); %linear  Best variable version

h = @(p) huniform(p,h_max,h_min); h_min = h_max;% easiest to solve

%% Mesh run

% [p,t,its]=CB_distmesh2d_mpc(fdFunc,h,h_max,h_min,bounds,pfix,pmpc,tol,1);
A = rand(3,3);
b = rand(3,1);
x = A\b;

for MPCType = 1:1:3
    rand('state',1) %Reset rand state so each one has same start point
    tic
    [p,t,its] = CB_distmesh2d_mpc(fdFunc,h,h_max,h_min,bounds,pfix,pmpc,tol,MPCType);
    time = toc;
    qual = simpqual(p,t,1);
    qual = min(qual);
    Vals(MPCType,:) = [MPCType, its, time, qual, time/its];
    
end
Vals