%MESHDEMO2d Distmesh2d examples.
clear all;  close all; format short; format compact
% clc;
rand('state',1); % Always the same results this is important for evaluating the methods against each other.
set(gcf,'renderer','opengl');

fstats=@(p,t) fprintf('%d nodes, %d elements, min quality %.2f\n', ...
    size(p,1),size(t,1),min(simpqual(p,t)));

fprintf('Mesh on ellipse');
% echo on

%% Cb2 FIXED Points on surface

pfix = zeros(0,2);
pmpc = zeros(0,2);

tic
tol = 10^-8;

%% Function assignment

fdFunc = EllipseFunction1;
% fdFunc = EllipseFunction3;

pfix = fdFunc.pfix;


tic;
%% Element size distributions
h_max = 0.1;
h_min = .005;

%     h = @(p) hcircleout(p,h_max,h_min); % gauss
%     h = @(p) hradialgenerator(p,h_max,h_min); % gauss
h = @(p) hradialgenerator2linear(p,h_max,h_min); %linear  Best variable version
% h = @(p) hradialgenerator2linearGrowthRate(p,h_max,h_min); %linear  Best variable version

h = @(p) huniform(p,h_max,h_min); h_min = h_max;% easiest to solve

%% Mesh run

% [p,t,its]=CB_distmesh2d_mpc(fdFunc,h,h_max,h_min,bounds,pfix,pmpc,tol,1);
A = rand(3,3);
b = rand(3,1);
x = A\b;

ElipCount = 0

Params = [1 1
          1 2
          1 4
          1 8  
          1 16
          1 32];

Area = 1;
Areas = Params(:,1).*Params(:,2);

ConstParams = [Params(:,1)./Areas.^0.5, Params(:,2)./Areas.^0.5];
      
      
% for i = 1:size(Params,1)
%         
%     fdFunc.Params = ConstParams(i,:)';
%     
%     
%     bounds = fdFunc.pbounds;
%     pfix = fdFunc.pfix;
%     for MPCType = 1:1:1
%         rand('state',1) %Reset rand state so each one has same start point
%         tic
%         [p,t,its,sensout] = CB_distmesh2d_mpc(fdFunc,h,h_max,h_min,bounds,pfix,pmpc,tol,MPCType);
%         time = toc;
%         qual = simpqual(p,t,1);
%         qual = min(qual);
%         Vals(MPCType,:) = [MPCType, its, time, qual, time/its];
%     end
%     
%     SenP1D1(i,:) = sensout.sensNorms1(1,:);
%     SenP1D2(i,:) = sensout.sensNorms1(2,:);
%     SenP2D1(i,:) = sensout.sensNorms2(1,:);
%     SenP2D2(i,:) = sensout.sensNorms2(2,:);
%     
%     AveP1D1(i,:) = sensout.sensAves1(1,:);
%     AveP1D2(i,:) = sensout.sensAves1(2,:);
%     AveP2D1(i,:) = sensout.sensAves2(1,:);
%     AveP2D2(i,:) = sensout.sensAves2(2,:);
% 
% end

% Vals


fdFunc.Params = [1 4]';
Hs = [0.25 0.2 0.15 0.1 0.05 0.025]';

for i = 1:size(Hs,1)
    
    h_max = Hs(i,1);
    
    h = @(p) huniform(p,h_max,h_min); h_min = h_max;
    
    bounds = fdFunc.pbounds;
    pfix = fdFunc.pfix;
    for MPCType = 1:1:1
        rand('state',1) %Reset rand state so each one has same start point
        tic
        [p,t,its,sensout] = CB_distmesh2d_mpc(fdFunc,h,h_max,h_min,bounds,pfix,pmpc,tol,MPCType);
        time = toc;
        qual = simpqual(p,t,1);
        qual = min(qual);
        Vals(MPCType,:) = [MPCType, its, time, qual, time/its];
    end
    
    Ps(1,i) = size(p,1);
    SenP1D1(i,:) = sensout.sensNorms1(1,:);
    SenP1D2(i,:) = sensout.sensNorms1(2,:);
    SenP2D1(i,:) = sensout.sensNorms2(1,:);
    SenP2D2(i,:) = sensout.sensNorms2(2,:);
    
    AveP1D1(i,:) = sensout.sensAves1(1,:);
    AveP1D2(i,:) = sensout.sensAves1(2,:);
    AveP2D1(i,:) = sensout.sensAves2(1,:);
    AveP2D2(i,:) = sensout.sensAves2(2,:);

end



