clc; close all; clear all;

load('Sensinf3.mat')
load('Sensinf4.mat')
dp = 0.1
changes = [-dp  0 0 0
    0  -dp 0 0
    0  0 0 dp];

plotno = 20;

for change = changes'
    plotno = plotno+1;
    UPDATER = sensitivityMat2*change;
    MESHplotter3D(p + [UPDATER(1:3:end,1), UPDATER(2:3:end,1), UPDATER(3:3:end,1)] ,tet,plotno)
    simpplot(p + [UPDATER(1:3:end,1), UPDATER(2:3:end,1), UPDATER(3:3:end,1)] ,tet)
    
    tmpfunc = fFunc;tmpfunc.Params = tmpfunc.Params + change;
    xy = tmpfunc.plot;
    hold on;
%     plot(xy(:,1),xy(:,2),'r-','LineWidth',1.5)
%     plot(xyorig(:,1),xyorig(:,2),'b-');
    %     EdgePlot(p,tet);
    legend({'0.8 <= Qual','0.4 <= Qual < 0.8','Qual < 0.4','New Boundary','Original Boundary','Original Mesh'},'Location','northeastoutside')
     zlabel('z')
    xlabel('x')
    ylabel('y')
    axis([-fFunc.Xscale fFunc.Xscale -fFunc.Yscale fFunc.Yscale -fFunc.Zscale fFunc.Zscale])
    hold on
    fixes = fFunc.pfix
    plot3(fixes(:,1),fixes(:,2),fixes(:,3),'k*')
end


plotno = 50;
for i = 1:4
    plotno = plotno+1;
    figure(plotno)
    mags = sqrt(sum([sensitivityMat2(1:3:end,i), sensitivityMat2(2:3:end,i), sensitivityMat2(3:3:end,i)].^2,2));
    gradsimpplot3d(p,tet,'p(:,2)>0 | p(:,1)>0',mags)
    zlabel('z')
    xlabel('x')
    ylabel('y')
    axis([-fFunc.Xscale fFunc.Xscale -fFunc.Yscale fFunc.Yscale -fFunc.Zscale fFunc.Zscale])
end



dp = 0.075
change = [0  0 0 dp]';

    plotno = plotno+1;
    figure(plotno)
    UPDATER = sensitivityMat2*change;
    mags = sqrt(sum([sensitivityMat2(1:3:end,i), sensitivityMat2(2:3:end,i), sensitivityMat2(3:3:end,i)].^2,2));
    ln = gradsimpplot3d(p + [UPDATER(1:3:end,1), UPDATER(2:3:end,1), UPDATER(3:3:end,1)] ,tet,[],mags)
    ln.FaceColor = [1 1 1];
    ln = gradsimpplot3d(p*1.005  ,tet,[],mags)
    ln.FaceColor = [1 1 1];
    ln.EdgeColor = 'k'
    ln.FaceAlpha = 0
    ln.LineStyle = ':'
    axes1 = gca;
    set(axes1,'CameraPosition',...
    [-11.8982420147987 -11.8982420147987 16.8266552257257],'CameraUpVector',...
    [0 0 1],'CameraViewAngle',7.6380971321916,'DataAspectRatio',[1 1 1],...
    'PlotBoxAspectRatio',[1.11111111111111 1.22222222222222 1]);
    legend('Updated mesh','Orignal mesh')

    zlabel('z')
    xlabel('x')
    ylabel('y')



plotno = 70;

    plotno = plotno+1;
    figure(plotno)
    upp = p + [UPDATER(1:3:end,1), UPDATER(2:3:end,1), UPDATER(3:3:end,1)];
    trisurf = surftri(p,tet);
    psexist = unique(trisurf);
    
    
      
    magsUpp = zeros(size(p,1),1);
    magsUpp(psexist) = sum(fFunc.fd(upp(psexist,:)).^2,2).^0.5;
    
%     mags = sqrt(sum([sensitivityMat2(1:3:end,i), sensitivityMat2(2:3:end,i), sensitivityMat2(3:3:end,i)].^2,2));
    gradsimpplot3d(upp,tet,'p(:,2)>-10 | p(:,1)>-10',magsUpp)
    zlabel('z')
    xlabel('x')
    ylabel('y')
    axis([-fFunc.Xscale fFunc.Xscale -fFunc.Yscale fFunc.Yscale -fFunc.Zscale fFunc.Zscale])



    plotno = plotno+1;
    figure(plotno)
    upp = p + [UPDATER(1:3:end,1), UPDATER(2:3:end,1), UPDATER(3:3:end,1)];
    trisurf = surftri(p,tet);
    psexist = unique(trisurf);
    
    
      
    magsUpp2 = zeros(size(p,1),1);
    magsUpp2(psexist) = sum((upp(psexist,:) - p(psexist,:)).^2,2).^0.5;
    
%     mags = sqrt(sum([sensitivityMat2(1:3:end,i), sensitivityMat2(2:3:end,i), sensitivityMat2(3:3:end,i)].^2,2));
    gradsimpplot3d(upp,tet,'p(:,2)>-10 | p(:,1)>-10',magsUpp2)
    zlabel('z')
    xlabel('x')
    ylabel('y')
    axis([-fFunc.Xscale fFunc.Xscale -fFunc.Yscale fFunc.Yscale -fFunc.Zscale fFunc.Zscale])
    

function [a] = MESHplotter3D(p,tet,fignum)
figure(fignum); cla
% simpplot(p,tet,'p(:,2)>0');
% title(['Retriangulation #'])
%         drawnow
t = unique(sort([tet(:,[1,2,3]);tet(:,[1,2,4]);tet(:,[1,3,4]);tet(:,[2,3,4]);],2),'rows');
cla;
s1 = patch('vertices',p,'faces',t,'edgecol','k','facecol',[.8,.9,1]);
s1.FaceAlpha = 1.00;
axis equal

% draw low quality elements
qual = simpqual(p,tet,1);
AD = find(qual<.2);

t = unique(sort([tet(AD,[1,2,3]);tet(AD,[1,2,4]);tet(AD,[1,3,4]);tet(AD,[2,3,4]);],2),'rows');

% hold on
% s2 = patch('vertices',p,'faces',t,'edgecol','k','facecol','r'); drawnow;
% s2.FaceAlpha = 1.0;
% hold off
end
