function[dFdu,broken,Ft] = CB_2dtruss_CT(x,Ldes,TrussType,TrussS)

x1 = x(1);
x2 = x(2);
x3 = x(3);
x4 = x(4);

broken = false;

type = TrussType-1;   S1 = TrussS;

Lc = ((x4-x2)^2+(x3-x1)^2)^0.5;

if round(Lc*10000) == 0
    broken = true;
end

if type == 0
    %linear divided current length
    
    Fbar = (Ldes-Lc)/Lc;
    
    l = (x3-x1)/Lc;
    m = (x4-x2)/Lc;
    
    F1x1 = (Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))/((x1-x3)^2+(x2-x4)^2)-(x1-x3)^2/((x1-x3)^2+(x2-x4)^2)^(3/2)-((2*x1-2*x3)*(x1-x3)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)^2;
    F1x2 = -((2*Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))*(x1-x3)*(x2-x4))/(x1^2-2*x1*x3+x2^2-2*x2*x4+x3^2+x4^2)^2;
    F1x3 = (x1-x3)^2/((x1-x3)^2+(x2-x4)^2)^(3/2)-(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))/((x1-x3)^2+(x2-x4)^2)+((2*x1-2*x3)*(x1-x3)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)^2;
    F1x4 = ((2*Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))*(x1-x3)*(x2-x4))/(x1^2-2*x1*x3+x2^2-2*x2*x4+x3^2+x4^2)^2;
    F2x1 = -((2*Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))*(x1-x3)*(x2-x4))/(x1^2-2*x1*x3+x2^2-2*x2*x4+x3^2+x4^2)^2;
    F2x2 = (Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))/((x1-x3)^2+(x2-x4)^2)-(x2-x4)^2/((x1-x3)^2+(x2-x4)^2)^(3/2)-((2*x2-2*x4)*(x2-x4)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)^2;
    F2x3 = ((2*Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))*(x1-x3)*(x2-x4))/(x1^2-2*x1*x3+x2^2-2*x2*x4+x3^2+x4^2)^2;
    F2x4 = (x2-x4)^2/((x1-x3)^2+(x2-x4)^2)^(3/2)-(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))/((x1-x3)^2+(x2-x4)^2)+((2*x2-2*x4)*(x2-x4)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)^2;
    F3x1 = (x1-x3)^2/((x1-x3)^2+(x2-x4)^2)^(3/2)-(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))/((x1-x3)^2+(x2-x4)^2)+((2*x1-2*x3)*(x1-x3)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)^2;
    F3x2 = ((2*Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))*(x1-x3)*(x2-x4))/(x1^2-2*x1*x3+x2^2-2*x2*x4+x3^2+x4^2)^2;
    F3x3 = (Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))/((x1-x3)^2+(x2-x4)^2)-(x1-x3)^2/((x1-x3)^2+(x2-x4)^2)^(3/2)-((2*x1-2*x3)*(x1-x3)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)^2;
    F3x4 = -((2*Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))*(x1-x3)*(x2-x4))/(x1^2-2*x1*x3+x2^2-2*x2*x4+x3^2+x4^2)^2;
    F4x1 = ((2*Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))*(x1-x3)*(x2-x4))/(x1^2-2*x1*x3+x2^2-2*x2*x4+x3^2+x4^2)^2;
    F4x2 = (x2-x4)^2/((x1-x3)^2+(x2-x4)^2)^(3/2)-(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))/((x1-x3)^2+(x2-x4)^2)+((2*x2-2*x4)*(x2-x4)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)^2;
    F4x3 = -((2*Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))*(x1-x3)*(x2-x4))/(x1^2-2*x1*x3+x2^2-2*x2*x4+x3^2+x4^2)^2;
    F4x4 = (Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))/((x1-x3)^2+(x2-x4)^2)-(x2-x4)^2/((x1-x3)^2+(x2-x4)^2)^(3/2)-((2*x2-2*x4)*(x2-x4)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)^2;
    
elseif type == 1
    %linear divided desired length
    Fbar = (Ldes-Lc)/Ldes;

    l = (x3-x1)/Lc;
    m = (x4-x2)/Lc;
    
    F1x1 = (Ldes*x2^2+Ldes*x4^2-((x1-x3)^2+(x2-x4)^2)^(3/2)-2*Ldes*x2*x4)/(Ldes*((x1-x3)^2+(x2-x4)^2)^(3/2));
    F1x2 = -((x1-x3)*(x2-x4))/((x1-x3)^2+(x2-x4)^2)^(3/2);
    F1x3 = -(Ldes*x2^2+Ldes*x4^2-((x1-x3)^2+(x2-x4)^2)^(3/2)-2*Ldes*x2*x4)/(Ldes*((x1-x3)^2+(x2-x4)^2)^(3/2));
    F1x4 = ((x1-x3)*(x2-x4))/((x1-x3)^2+(x2-x4)^2)^(3/2);
    F2x1 = -((x1-x3)*(x2-x4))/((x1-x3)^2+(x2-x4)^2)^(3/2);
    F2x2 = (Ldes*x1^2+Ldes*x3^2-((x1-x3)^2+(x2-x4)^2)^(3/2)-2*Ldes*x1*x3)/(Ldes*((x1-x3)^2+(x2-x4)^2)^(3/2));
    F2x3 = ((x1-x3)*(x2-x4))/((x1-x3)^2+(x2-x4)^2)^(3/2);
    F2x4 = -(Ldes*x1^2+Ldes*x3^2-((x1-x3)^2+(x2-x4)^2)^(3/2)-2*Ldes*x1*x3)/(Ldes*((x1-x3)^2+(x2-x4)^2)^(3/2));
    F3x1 = -(Ldes*x2^2+Ldes*x4^2-((x1-x3)^2+(x2-x4)^2)^(3/2)-2*Ldes*x2*x4)/(Ldes*((x1-x3)^2+(x2-x4)^2)^(3/2));
    F3x2 = ((x1-x3)*(x2-x4))/((x1-x3)^2+(x2-x4)^2)^(3/2);
    F3x3 = (Ldes*x2^2+Ldes*x4^2-((x1-x3)^2+(x2-x4)^2)^(3/2)-2*Ldes*x2*x4)/(Ldes*((x1-x3)^2+(x2-x4)^2)^(3/2));
    F3x4 = -((x1-x3)*(x2-x4))/((x1-x3)^2+(x2-x4)^2)^(3/2);
    F4x1 = ((x1-x3)*(x2-x4))/((x1-x3)^2+(x2-x4)^2)^(3/2);
    F4x2 = -(Ldes*x1^2+Ldes*x3^2-((x1-x3)^2+(x2-x4)^2)^(3/2)-2*Ldes*x1*x3)/(Ldes*((x1-x3)^2+(x2-x4)^2)^(3/2));
    F4x3 = -((x1-x3)*(x2-x4))/((x1-x3)^2+(x2-x4)^2)^(3/2);
    F4x4 = (Ldes*x1^2+Ldes*x3^2-((x1-x3)^2+(x2-x4)^2)^(3/2)-2*Ldes*x1*x3)/(Ldes*((x1-x3)^2+(x2-x4)^2)^(3/2));
    
elseif type == 2
    %Exponential over current length
  
    Fbar = ((Ldes-Lc)/Lc)*exp(S1*abs((Ldes-Lc)/Lc));
    
    l = (x3-x1)/Lc;
    m = (x4-x2)/Lc;
    
    F1x1 = (exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)-(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(2*x1-2*x3)*(x1-x3))/(2*((x1-x3)^2+(x2-x4)^2)^(3/2))-(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(2*x1-2*x3)*(x1-x3)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)^2-(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(x1-x3)*((S1*(2*x1-2*x3)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)^(3/2)+(S1*(2*x1-2*x3)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2)^2)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2);
    F1x2 = -(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(2*x2-2*x4)*(x1-x3))/(2*((x1-x3)^2+(x2-x4)^2)^(3/2))-(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(2*x2-2*x4)*(x1-x3)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)^2-(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(x1-x3)*((S1*(2*x2-2*x4)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)^(3/2)+(S1*(2*x2-2*x4)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2)^2)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2);
    F1x3 = (exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(2*x1-2*x3)*(x1-x3))/(2*((x1-x3)^2+(x2-x4)^2)^(3/2))-(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)+(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(2*x1-2*x3)*(x1-x3)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)^2+(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(x1-x3)*((S1*(2*x1-2*x3)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)^(3/2)+(S1*(2*x1-2*x3)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2)^2)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2);
    F1x4 = (exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(2*x2-2*x4)*(x1-x3))/(2*((x1-x3)^2+(x2-x4)^2)^(3/2))+(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(2*x2-2*x4)*(x1-x3)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)^2+(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(x1-x3)*((S1*(2*x2-2*x4)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)^(3/2)+(S1*(2*x2-2*x4)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2)^2)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2);
    F2x1 = -(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(2*x1-2*x3)*(x2-x4))/(2*((x1-x3)^2+(x2-x4)^2)^(3/2))-(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(2*x1-2*x3)*(x2-x4)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)^2-(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(x2-x4)*((S1*(2*x1-2*x3)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)^(3/2)+(S1*(2*x1-2*x3)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2)^2)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2);
    F2x2 = (exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)-(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(2*x2-2*x4)*(x2-x4))/(2*((x1-x3)^2+(x2-x4)^2)^(3/2))-(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(2*x2-2*x4)*(x2-x4)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)^2-(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(x2-x4)*((S1*(2*x2-2*x4)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)^(3/2)+(S1*(2*x2-2*x4)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2)^2)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2);
    F2x3 = (exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(2*x1-2*x3)*(x2-x4))/(2*((x1-x3)^2+(x2-x4)^2)^(3/2))+(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(2*x1-2*x3)*(x2-x4)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)^2+(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(x2-x4)*((S1*(2*x1-2*x3)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)^(3/2)+(S1*(2*x1-2*x3)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2)^2)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2);
    F2x4 = (exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(2*x2-2*x4)*(x2-x4))/(2*((x1-x3)^2+(x2-x4)^2)^(3/2))-(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)+(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(2*x2-2*x4)*(x2-x4)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)^2+(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(x2-x4)*((S1*(2*x2-2*x4)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)^(3/2)+(S1*(2*x2-2*x4)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2)^2)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2);
    F3x1 = (exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(2*x1-2*x3)*(x1-x3))/(2*((x1-x3)^2+(x2-x4)^2)^(3/2))-(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)+(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(2*x1-2*x3)*(x1-x3)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)^2+(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(x1-x3)*((S1*(2*x1-2*x3)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)^(3/2)+(S1*(2*x1-2*x3)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2)^2)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2);
    F3x2 = (exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(2*x2-2*x4)*(x1-x3))/(2*((x1-x3)^2+(x2-x4)^2)^(3/2))+(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(2*x2-2*x4)*(x1-x3)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)^2+(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(x1-x3)*((S1*(2*x2-2*x4)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)^(3/2)+(S1*(2*x2-2*x4)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2)^2)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2);
    F3x3 = (exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)-(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(2*x1-2*x3)*(x1-x3))/(2*((x1-x3)^2+(x2-x4)^2)^(3/2))-(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(2*x1-2*x3)*(x1-x3)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)^2-(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(x1-x3)*((S1*(2*x1-2*x3)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)^(3/2)+(S1*(2*x1-2*x3)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2)^2)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2);
    F3x4 = -(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(2*x2-2*x4)*(x1-x3))/(2*((x1-x3)^2+(x2-x4)^2)^(3/2))-(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(2*x2-2*x4)*(x1-x3)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)^2-(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(x1-x3)*((S1*(2*x2-2*x4)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)^(3/2)+(S1*(2*x2-2*x4)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2)^2)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2);
    F4x1 = (exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(2*x1-2*x3)*(x2-x4))/(2*((x1-x3)^2+(x2-x4)^2)^(3/2))+(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(2*x1-2*x3)*(x2-x4)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)^2+(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(x2-x4)*((S1*(2*x1-2*x3)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)^(3/2)+(S1*(2*x1-2*x3)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2)^2)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2);
    F4x2 = (exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(2*x2-2*x4)*(x2-x4))/(2*((x1-x3)^2+(x2-x4)^2)^(3/2))-(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)+(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(2*x2-2*x4)*(x2-x4)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)^2+(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(x2-x4)*((S1*(2*x2-2*x4)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)^(3/2)+(S1*(2*x2-2*x4)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2)^2)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2);
    F4x3 = -(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(2*x1-2*x3)*(x2-x4))/(2*((x1-x3)^2+(x2-x4)^2)^(3/2))-(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(2*x1-2*x3)*(x2-x4)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)^2-(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(x2-x4)*((S1*(2*x1-2*x3)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)^(3/2)+(S1*(2*x1-2*x3)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2)^2)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2);
    F4x4 = (exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)-(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(2*x2-2*x4)*(x2-x4))/(2*((x1-x3)^2+(x2-x4)^2)^(3/2))-(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(2*x2-2*x4)*(x2-x4)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)^2-(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2))*(x2-x4)*((S1*(2*x2-2*x4)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2)^(3/2)+(S1*(2*x2-2*x4)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/((x1-x3)^2+(x2-x4)^2)^2)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/((x1-x3)^2+(x2-x4)^2);

    
elseif type == 3
    %Exponentialoverdesiredlength
  
    Fbar = ((Ldes-Lc)/Ldes)*exp(S1*((Ldes-Lc)/Ldes)^2);
    
    l = (x3-x1)/Lc;
    m = (x4-x2)/Lc;
    
    F1x1 = (exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/(Ldes*((x1-x3)^2+(x2-x4)^2)^(1/2))-(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x1-2*x3)*(x1-x3))/(2*Ldes*((x1-x3)^2+(x2-x4)^2))-(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x1-2*x3)*(x1-x3)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/(2*Ldes*((x1-x3)^2+(x2-x4)^2)^(3/2))-(S1*exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x1-2*x3)*(x1-x3)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/(Ldes^3*((x1-x3)^2+(x2-x4)^2));
    F1x2 = -(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x2-2*x4)*(x1-x3))/(2*Ldes*((x1-x3)^2+(x2-x4)^2))-(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x2-2*x4)*(x1-x3)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/(2*Ldes*((x1-x3)^2+(x2-x4)^2)^(3/2))-(S1*exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x2-2*x4)*(x1-x3)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/(Ldes^3*((x1-x3)^2+(x2-x4)^2));
    F1x3 = (exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x1-2*x3)*(x1-x3))/(2*Ldes*((x1-x3)^2+(x2-x4)^2))-(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/(Ldes*((x1-x3)^2+(x2-x4)^2)^(1/2))+(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x1-2*x3)*(x1-x3)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/(2*Ldes*((x1-x3)^2+(x2-x4)^2)^(3/2))+(S1*exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x1-2*x3)*(x1-x3)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/(Ldes^3*((x1-x3)^2+(x2-x4)^2));
    F1x4 = (exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x2-2*x4)*(x1-x3))/(2*Ldes*((x1-x3)^2+(x2-x4)^2))+(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x2-2*x4)*(x1-x3)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/(2*Ldes*((x1-x3)^2+(x2-x4)^2)^(3/2))+(S1*exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x2-2*x4)*(x1-x3)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/(Ldes^3*((x1-x3)^2+(x2-x4)^2));
    F2x1 = -(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x1-2*x3)*(x2-x4))/(2*Ldes*((x1-x3)^2+(x2-x4)^2))-(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x1-2*x3)*(x2-x4)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/(2*Ldes*((x1-x3)^2+(x2-x4)^2)^(3/2))-(S1*exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x1-2*x3)*(x2-x4)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/(Ldes^3*((x1-x3)^2+(x2-x4)^2));
    F2x2 = (exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/(Ldes*((x1-x3)^2+(x2-x4)^2)^(1/2))-(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x2-2*x4)*(x2-x4))/(2*Ldes*((x1-x3)^2+(x2-x4)^2))-(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x2-2*x4)*(x2-x4)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/(2*Ldes*((x1-x3)^2+(x2-x4)^2)^(3/2))-(S1*exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x2-2*x4)*(x2-x4)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/(Ldes^3*((x1-x3)^2+(x2-x4)^2));
    F2x3 = (exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x1-2*x3)*(x2-x4))/(2*Ldes*((x1-x3)^2+(x2-x4)^2))+(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x1-2*x3)*(x2-x4)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/(2*Ldes*((x1-x3)^2+(x2-x4)^2)^(3/2))+(S1*exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x1-2*x3)*(x2-x4)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/(Ldes^3*((x1-x3)^2+(x2-x4)^2));
    F2x4 = (exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x2-2*x4)*(x2-x4))/(2*Ldes*((x1-x3)^2+(x2-x4)^2))-(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/(Ldes*((x1-x3)^2+(x2-x4)^2)^(1/2))+(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x2-2*x4)*(x2-x4)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/(2*Ldes*((x1-x3)^2+(x2-x4)^2)^(3/2))+(S1*exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x2-2*x4)*(x2-x4)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/(Ldes^3*((x1-x3)^2+(x2-x4)^2));
    F3x1 = (exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x1-2*x3)*(x1-x3))/(2*Ldes*((x1-x3)^2+(x2-x4)^2))-(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/(Ldes*((x1-x3)^2+(x2-x4)^2)^(1/2))+(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x1-2*x3)*(x1-x3)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/(2*Ldes*((x1-x3)^2+(x2-x4)^2)^(3/2))+(S1*exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x1-2*x3)*(x1-x3)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/(Ldes^3*((x1-x3)^2+(x2-x4)^2));
    F3x2 = (exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x2-2*x4)*(x1-x3))/(2*Ldes*((x1-x3)^2+(x2-x4)^2))+(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x2-2*x4)*(x1-x3)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/(2*Ldes*((x1-x3)^2+(x2-x4)^2)^(3/2))+(S1*exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x2-2*x4)*(x1-x3)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/(Ldes^3*((x1-x3)^2+(x2-x4)^2));
    F3x3 = (exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/(Ldes*((x1-x3)^2+(x2-x4)^2)^(1/2))-(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x1-2*x3)*(x1-x3))/(2*Ldes*((x1-x3)^2+(x2-x4)^2))-(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x1-2*x3)*(x1-x3)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/(2*Ldes*((x1-x3)^2+(x2-x4)^2)^(3/2))-(S1*exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x1-2*x3)*(x1-x3)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/(Ldes^3*((x1-x3)^2+(x2-x4)^2));
    F3x4 = -(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x2-2*x4)*(x1-x3))/(2*Ldes*((x1-x3)^2+(x2-x4)^2))-(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x2-2*x4)*(x1-x3)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/(2*Ldes*((x1-x3)^2+(x2-x4)^2)^(3/2))-(S1*exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x2-2*x4)*(x1-x3)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/(Ldes^3*((x1-x3)^2+(x2-x4)^2));
    F4x1 = (exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x1-2*x3)*(x2-x4))/(2*Ldes*((x1-x3)^2+(x2-x4)^2))+(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x1-2*x3)*(x2-x4)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/(2*Ldes*((x1-x3)^2+(x2-x4)^2)^(3/2))+(S1*exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x1-2*x3)*(x2-x4)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/(Ldes^3*((x1-x3)^2+(x2-x4)^2));
    F4x2 = (exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x2-2*x4)*(x2-x4))/(2*Ldes*((x1-x3)^2+(x2-x4)^2))-(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/(Ldes*((x1-x3)^2+(x2-x4)^2)^(1/2))+(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x2-2*x4)*(x2-x4)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/(2*Ldes*((x1-x3)^2+(x2-x4)^2)^(3/2))+(S1*exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x2-2*x4)*(x2-x4)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/(Ldes^3*((x1-x3)^2+(x2-x4)^2));
    F4x3 = -(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x1-2*x3)*(x2-x4))/(2*Ldes*((x1-x3)^2+(x2-x4)^2))-(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x1-2*x3)*(x2-x4)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/(2*Ldes*((x1-x3)^2+(x2-x4)^2)^(3/2))-(S1*exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x1-2*x3)*(x2-x4)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/(Ldes^3*((x1-x3)^2+(x2-x4)^2));
    F4x4 = (exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/(Ldes*((x1-x3)^2+(x2-x4)^2)^(1/2))-(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x2-2*x4)*(x2-x4))/(2*Ldes*((x1-x3)^2+(x2-x4)^2))-(exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x2-2*x4)*(x2-x4)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2)))/(2*Ldes*((x1-x3)^2+(x2-x4)^2)^(3/2))-(S1*exp((S1*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/Ldes^2)*(2*x2-2*x4)*(x2-x4)*(Ldes-((x1-x3)^2+(x2-x4)^2)^(1/2))^2)/(Ldes^3*((x1-x3)^2+(x2-x4)^2));
    
end

%Forcevectorconstribution
Ft(1,1) = -Fbar*l;
Ft(2,1) = -Fbar*m;
Ft(3,1) = Fbar*l;
Ft(4,1) = Fbar*m;


dFdu = [F1x1 F1x2 F1x3 F1x4;
        F2x1 F2x2 F2x3 F2x4;
        F3x1 F3x2 F3x3 F3x4;
        F4x1 F4x2 F4x3 F4x4];
